module BotMob
  # ## BotMob::Connection
  #
  # The Connection is the point of contact
  # between the Bot and the specified network
  class Connection
    attr_reader :bot, :options

    def initialize(bot, **options)
      @bot = bot
      @options = options
    end

    def self.setup(network, bot, options = {})
      connection_delegate(network).new(bot, options)
    end

    def deliver(outbound_message, _options = {})
      # deliver(outbound_message, options)
      # noop
      outbound_message
    end

    class << self
      private

      def connection_delegate(network)
        delegate = BotMob::Networks.const_get(network.to_s.camelize)
        delegate.const_get('Connection')
      rescue NameError
        raise BotMob::InvalidNetworkError
      end
    end
  end
end
