module BotMob
  # ## BotMob::Environment
  #
  # Provide convenience methods for tracking current
  # BotMob runtime environment. Set using the environment
  # variable: `ENV['MOB_ENV']`
  class Environment
    def initialize(env = nil)
      @env = env || 'development'
    end

    def to_s
      @env
    end

    def respond_to_missing?(method_name, include_private = false)
      method_name.to_s[/(.*)\?$/, 1] || super
    end

    def method_missing(method_name, *args)
      environment = method_name.to_s[/(.*)\?$/, 1]
      environment ? @env == environment : super
    end
  end
end
