module BotMob
  # # BotMob::Logger
  #
  # Wrapper for the logger implemented by BotMob
  class Logger < ::Logger
    OMITTED_PARAMS = %w(splat captures).freeze

    def log_request(source, action = :request, params = {})
      source_network = params[:network] || 'roaming'
      ts = Time.now.strftime('%Y-%m-%d %H:%M:%S%Z')

      info "\n#{source.name} received #{action} from :#{source_network} at #{ts}"
      info "Parameters: #{logged_params(params).inspect}"
    end

    private

    def logged_params(params)
      params.reject { |k, _| OMITTED_PARAMS.include?(k) }
    end
  end
end
