module BotMob
  module Networks
    module Roaming
      # ## BotMob::Networks::Roaming::Connection
      #
      # The Connection is the point of contact
      # between the Bot and the specified network
      class Connection < BotMob::Connection
        attr_reader :bot

        def deliver(outbound_message, _options = {})
          BotMob.logger.info "  Roaming Connection Sent: #{outbound_message.inspect}"
          outbound_message
        end

        def connect
          BotMob.logger.info 'Connecting... '
        end

        def reconnect
          BotMob.logger.info 'Reconnecting... '
        end

        def refresh
          BotMob.logger.info 'Refreshing... '
        end

        def client
          self
        end
      end
    end
  end
end
