module BotMob
  module Networks
    module Slack
      # # BotMob::InboundMessage
      #
      # Structured data provided to a bot by Slack via sinatra params
      # {
      #   "token": "NiI3K5i7SORx0MAf8U9QRfCX",
      #   "team_id": "T09K1L491",
      #   "team_domain": "foobar",
      #   "service_id": "16319829032",
      #   "channel_id": "C29R5RZLN",
      #   "channel_name": "general",
      #   "timestamp": "1482729119.000014",
      #   "user_id": "U07R1RUJA",
      #   "user_name": "matthew",
      #   "text": "Hi Everyone!",
      #   "splat": [],
      #   "captures": [
      #     "slack"
      #   ],
      #   "network": "slack"
      # }
      class InboundMessage < BotMob::InboundMessage
        message_attrs :domain, :channel_name, :user_name, :timestamp,
                      :token, :team_id, :service_id, :channel_id, :user_id

        def initialize(**options)
          @network = :slack
          @body = options[:text]
          super
        end
      end
    end
  end
end
