module BotMob
  # # BotMob::OutboundMessage
  #
  # Strucutred data for all messages leaving your bot
  class OutboundMessage
    attr_reader :body, :network, :inbound

    def initialize(**options)
      @network ||= options[:network]
      @inbound = options[:inbound]
      @body = options[:body]
    end

    def self.prepare(message, options = {})
      return message if message.is_a?(BotMob::OutboundMessage)

      target_network = options[:inbound].network
      message_delegate(target_network).new(options.merge(body: message))
    end

    class << self
      private

      def message_delegate(network)
        delegate = BotMob::Networks.const_get(network.to_s.camelize)
        delegate.const_get('OutboundMessage')
      rescue NameError
        raise BotMob::InvalidNetworkError
      end
    end
  end
end
