require 'sinatra/base'

module BotMob
  # # BotMob::Server
  #
  # Basic server for external access to
  # connected bots.
  class Server < Sinatra::Base
    def self.run!(**options)
      set :roster, options[:roster] || BotMob::Roster.new
      super
    end

    def name
      'Server'
    end

    get '/' do
      erb :index
    end

    get '/console' do
      erb :console
    end

    get '/:network/callback' do
      BotMob.logger.log_request(self, :callback, params)

      case params[:network].to_sym
      when :facebook
        params['hub.challenge']
      else
        erb :authorize
      end
    end

    post '/:network/message' do
      BotMob.logger.log_request(self, :message, params)

      settings.roster.disseminate(:message, params).join(', ')
    end

    post '/:network/command/:method' do
      BotMob.logger.log_request(self, :command, params)

      settings.roster.disseminate(:command, params).join(', ')
    end
  end
end
